require 'spec_helper'

module Blamescope
  describe Middleware do
    describe "::new" do
      it "should configure application" do
        expect(Blamescope).to receive(:configure).with(:config)
        Middleware.new(:app, :config)
      end
    end

    describe "#call" do
      it "should set environment from request" do
        app = double('app')
        expect(Thread).to receive_message_chain(:current, :[]=).with(:env, :env)
        expect(app).to receive(:call).with(:env)
        subject = Middleware.new(app)
        subject.call(:env)
      end
    end
  end
end